<!-- Generated by documentation.js. Update this documentation by updating the source code. -->

### Table of Contents

-   [DOM Interaction Helpers][1]
    -   [blur][2]
        -   [Parameters][3]
    -   [click][4]
        -   [Parameters][5]
    -   [doubleClick][6]
        -   [Parameters][7]
    -   [fillIn][8]
        -   [Parameters][9]
    -   [focus][10]
        -   [Parameters][11]
    -   [tap][12]
        -   [Parameters][13]
    -   [triggerEvent][14]
        -   [Parameters][15]
        -   [Examples][16]
    -   [triggerKeyEvent][17]
        -   [Parameters][18]
    -   [typeIn][19]
        -   [Parameters][20]
-   [DOM Query Helpers][21]
    -   [find][22]
        -   [Parameters][23]
    -   [findAll][24]
        -   [Parameters][25]
    -   [getRootElement][26]
-   [Routing Helpers][27]
    -   [visit][28]
        -   [Parameters][29]
    -   [currentRouteName][30]
    -   [currentURL][31]
-   [Rendering Helpers][32]
    -   [render][33]
        -   [Parameters][34]
    -   [clearRender][35]
-   [Wait Helpers][36]
    -   [waitFor][37]
        -   [Parameters][38]
    -   [waitUntil][39]
        -   [Parameters][40]
    -   [settled][41]
    -   [isSettled][42]
    -   [getSettledState][43]
-   [Pause Helpers][44]
    -   [pauseTest][45]
        -   [Examples][46]
    -   [resumeTest][47]
-   [Test Framework APIs][48]
    -   [setResolver][49]
        -   [Parameters][50]
    -   [getResolver][51]
    -   [setupContext][52]
        -   [Parameters][53]
    -   [getContext][54]
    -   [setContext][55]
        -   [Parameters][56]
    -   [unsetContext][57]
    -   [teardownContext][58]
        -   [Parameters][59]
    -   [setupRenderingContext][60]
        -   [Parameters][61]
    -   [teardownRenderingContext][62]
        -   [Parameters][63]
    -   [getApplication][64]
    -   [setApplication][65]
        -   [Parameters][66]
    -   [setupApplicationContext][67]
        -   [Parameters][68]
    -   [teardownApplicationContext][69]
        -   [Parameters][70]
    -   [validateErrorHandler][71]
        -   [Parameters][72]
        -   [Examples][73]
-   [setupOnerror][74]
    -   [Parameters][75]

## DOM Interaction Helpers




### blur

Unfocus the specified target.

Sends a number of events intending to simulate a "real" user unfocusing an
element.

The following events are triggered (in order):

-   `blur`
-   `focusout`

The exact listing of events that are triggered may change over time as needed
to continue to emulate how actual browsers handle unfocusing a given element.

#### Parameters

-   `target` **([string][76] \| [Element][77])** the element or selector to unfocus (optional, default `document.activeElement`)

Returns **[Promise][78]&lt;void>** resolves when settled

### click

Clicks on the specified target.

Sends a number of events intending to simulate a "real" user clicking on an
element.

For non-focusable elements the following events are triggered (in order):

-   `mousedown`
-   `mouseup`
-   `click`

For focusable (e.g. form control) elements the following events are triggered
(in order):

-   `mousedown`
-   `focus`
-   `focusin`
-   `mouseup`
-   `click`

The exact listing of events that are triggered may change over time as needed
to continue to emulate how actual browsers handle clicking a given element.

Use the `options` hash to change the parameters of the MouseEvents.

#### Parameters

-   `target` **([string][76] \| [Element][77])** the element or selector to click on
-   `options` **[Object][79]** the options to be merged into the mouse events (optional, default `{}`)

Returns **[Promise][78]&lt;void>** resolves when settled

### doubleClick

Double-clicks on the specified target.

Sends a number of events intending to simulate a "real" user clicking on an
element.

For non-focusable elements the following events are triggered (in order):

-   `mousedown`
-   `mouseup`
-   `click`
-   `mousedown`
-   `mouseup`
-   `click`
-   `dblclick`

For focusable (e.g. form control) elements the following events are triggered
(in order):

-   `mousedown`
-   `focus`
-   `focusin`
-   `mouseup`
-   `click`
-   `mousedown`
-   `mouseup`
-   `click`
-   `dblclick`

The exact listing of events that are triggered may change over time as needed
to continue to emulate how actual browsers handle clicking a given element.

Use the `options` hash to change the parameters of the MouseEvents.

#### Parameters

-   `target` **([string][76] \| [Element][77])** the element or selector to double-click on
-   `options` **[Object][79]** the options to be merged into the mouse events (optional, default `{}`)

Returns **[Promise][78]&lt;void>** resolves when settled

### fillIn

Fill the provided text into the `value` property (or set `.innerHTML` when
the target is a content editable element) then trigger `change` and `input`
events on the specified target.

#### Parameters

-   `target` **([string][76] \| [Element][77])** the element or selector to enter text into
-   `text` **[string][76]** the text to fill into the target element

Returns **[Promise][78]&lt;void>** resolves when the application is settled

### focus

Focus the specified target.

Sends a number of events intending to simulate a "real" user focusing an
element.

The following events are triggered (in order):

-   `focus`
-   `focusin`

The exact listing of events that are triggered may change over time as needed
to continue to emulate how actual browsers handle focusing a given element.

#### Parameters

-   `target` **([string][76] \| [Element][77])** the element or selector to focus

Returns **[Promise][78]&lt;void>** resolves when the application is settled

### tap

Taps on the specified target.

Sends a number of events intending to simulate a "real" user tapping on an
element.

For non-focusable elements the following events are triggered (in order):

-   `touchstart`
-   `touchend`
-   `mousedown`
-   `mouseup`
-   `click`

For focusable (e.g. form control) elements the following events are triggered
(in order):

-   `touchstart`
-   `touchend`
-   `mousedown`
-   `focus`
-   `focusin`
-   `mouseup`
-   `click`

The exact listing of events that are triggered may change over time as needed
to continue to emulate how actual browsers handle tapping on a given element.

Use the `options` hash to change the parameters of the tap events.

#### Parameters

-   `target` **([string][76] \| [Element][77])** the element or selector to tap on
-   `options` **[Object][79]** the options to be merged into the touch events (optional, default `{}`)

Returns **[Promise][78]&lt;void>** resolves when settled

### triggerEvent

Triggers an event on the specified target.

#### Parameters

-   `target` **([string][76] \| [Element][77])** the element or selector to trigger the event on
-   `eventType` **[string][76]** the type of event to trigger
-   `options` **[Object][79]** additional properties to be set on the event

#### Examples

Using triggerEvent to Upload a file
When using triggerEvent to upload a file the `eventType` must be `change` and you must pass the
`options` param as an object with a key `files` containing an array of
[Blob][80].


```javascript
triggerEvent(
  'input.fileUpload',
  'change',
  [new Blob(['Ember Rules!'])]
);
```

Returns **[Promise][78]&lt;void>** resolves when the application is settled

### triggerKeyEvent

Triggers a keyboard event of given type in the target element.
It also requires the developer to provide either a string with the [`key`][81]
or the numeric [`keyCode`][82] of the pressed key.
Optionally the user can also provide a POJO with extra modifiers for the event.

#### Parameters

-   `target` **([string][76] \| [Element][77])** the element or selector to trigger the event on
-   `eventType` **(`"keydown"` \| `"keyup"` \| `"keypress"`)** the type of event to trigger
-   `key` **([number][83] \| [string][76])** the `keyCode`(number) or `key`(string) of the event being triggered
-   `modifiers` **[Object][79]?** the state of various modifier keys (optional, default `DEFAULT_MODIFIERS`)
    -   `modifiers.ctrlKey` **[boolean][84]** if true the generated event will indicate the control key was pressed during the key event (optional, default `false`)
    -   `modifiers.altKey` **[boolean][84]** if true the generated event will indicate the alt key was pressed during the key event (optional, default `false`)
    -   `modifiers.shiftKey` **[boolean][84]** if true the generated event will indicate the shift key was pressed during the key event (optional, default `false`)
    -   `modifiers.metaKey` **[boolean][84]** if true the generated event will indicate the meta key was pressed during the key event (optional, default `false`)

Returns **[Promise][78]&lt;void>** resolves when the application is settled

### typeIn

Mimics character by character entry into the target `input` or `textarea` element.

Allows for simulation of slow entry by passing an optional millisecond delay
between key events.

The major difference between `typeIn` and `fillIn` is that `typeIn` triggers
keyboard events as well as `input` and `change`.
Typically this looks like `focus` -> `focusin` -> `keydown` -> `keypress` -> `keyup` -> `input` -> `change`
per character of the passed text (this may vary on some browsers).

#### Parameters

-   `target` **([string][76] \| [Element][77])** the element or selector to enter text into
-   `text` **[string][76]** the test to fill the element with
-   `options` **[Object][79]** {delay: x} (default 50) number of milliseconds to wait per keypress (optional, default `{}`)

Returns **[Promise][78]&lt;void>** resolves when the application is settled

## DOM Query Helpers




### find

Find the first element matched by the given selector. Equivalent to calling
`querySelector()` on the test root element.

#### Parameters

-   `selector` **[string][76]** the selector to search for

Returns **[Element][77]** matched element or null

### findAll

Find all elements matched by the given selector. Similar to calling
`querySelectorAll()` on the test root element, but returns an array instead
of a `NodeList`.

#### Parameters

-   `selector` **[string][76]** the selector to search for

Returns **[Array][85]** array of matched elements

### getRootElement

Get the root element of the application under test (usually `#ember-testing`)

Returns **[Element][77]** the root element

## Routing Helpers




### visit

Navigate the application to the provided URL.

#### Parameters

-   `url` **[string][76]** The URL to visit (e.g. `/posts`)
-   `options` **[object][79]** app boot options

Returns **[Promise][78]&lt;void>** resolves when settled

### currentRouteName

Returns **[string][76]** the currently active route name

### currentURL

Returns **[string][76]** the applications current url

## Rendering Helpers




### render

Renders the provided template and appends it to the DOM.

#### Parameters

-   `template` **CompiledTemplate** the template to render

Returns **[Promise][78]&lt;void>** resolves when settled

### clearRender

Clears any templates previously rendered. This is commonly used for
confirming behavior that is triggered by teardown (e.g.
`willDestroyElement`).

Returns **[Promise][78]&lt;void>** resolves when settled

## Wait Helpers




### waitFor

Used to wait for a particular selector to appear in the DOM. Due to the fact
that it does not wait for general settledness, this is quite useful for testing
interim DOM states (e.g. loading states, pending promises, etc).

#### Parameters

-   `selector` **[string][76]** the selector to wait for
-   `options` **[Object][79]?** the options to be used (optional, default `{}`)
    -   `options.timeout` **[number][83]** the time to wait (in ms) for a match (optional, default `1000`)
    -   `options.count` **[number][83]** the number of elements that should match the provided selector (null means one or more) (optional, default `null`)

Returns **[Promise][78]&lt;([Element][77] \| [Array][85]&lt;[Element][77]>)>** resolves when the element(s) appear on the page

### waitUntil

Wait for the provided callback to return a truthy value.

This does not leverage `settled()`, and as such can be used to manage async
while _not_ settled (e.g. "loading" or "pending" states).

#### Parameters

-   `callback` **[Function][86]** the callback to use for testing when waiting should stop
-   `options` **[Object][79]?** options used to override defaults (optional, default `{}`)
    -   `options.timeout` **[number][83]** the maximum amount of time to wait (optional, default `1000`)
    -   `options.timeoutMessage` **[string][76]** the message to use in the reject on timeout (optional, default `'waitUntil timed out'`)

Returns **[Promise][78]** resolves with the callback value when it returns a truthy value

### settled

Returns a promise that resolves when in a settled state (see `isSettled` for
a definition of "settled state").

Returns **[Promise][78]&lt;void>** resolves when settled

### isSettled

Checks various settledness metrics (via `getSettledState()`) to determine if things are settled or not.

Settled generally means that there are no pending timers, no pending waiters,
no pending AJAX requests, and no current run loop. However, new settledness
metrics may be added and used as they become available.

Returns **[boolean][84]** `true` if settled, `false` otherwise

### getSettledState

Check various settledness metrics, and return an object with the following properties:

-   `hasRunLoop` - Checks if a run-loop has been started. If it has, this will
    be `true` otherwise it will be `false`.
-   `hasPendingTimers` - Checks if there are scheduled timers in the run-loop.
    These pending timers are primarily registered by `Ember.run.schedule`. If
    there are pending timers, this will be `true`, otherwise `false`.
-   `hasPendingWaiters` - Checks if any registered test waiters are still
    pending (e.g. the waiter returns `true`). If there are pending waiters,
    this will be `true`, otherwise `false`.
-   `hasPendingRequests` - Checks if there are pending AJAX requests (based on
    `ajaxSend` / `ajaxComplete` events triggered by `jQuery.ajax`). If there
    are pending requests, this will be `true`, otherwise `false`.
-   `pendingRequestCount` - The count of pending AJAX requests.

Returns **[Object][79]** object with properties for each of the metrics used to determine settledness

## Pause Helpers




### pauseTest

Returns a promise to be used to pauses the current test (due to being
returned from the test itself).  This is useful for debugging while testing
or for test-driving.  It allows you to inspect the state of your application
at any point.

The test framework wrapper (e.g. `ember-qunit` or `ember-mocha`) should
ensure that when `pauseTest()` is used, any framework specific test timeouts
are disabled.

#### Examples

Usage via ember-qunit


```javascript
import { setupRenderingTest } from 'ember-qunit';
import { render, click, pauseTest } from '@ember/test-helpers';


module('awesome-sauce', function(hooks) {
  setupRenderingTest(hooks);

  test('does something awesome', async function(assert) {
    await render(hbs`{{awesome-sauce}}`);

    // added here to visualize / interact with the DOM prior
    // to the interaction below
    await pauseTest();

    click('.some-selector');

    assert.equal(this.element.textContent, 'this sauce is awesome!');
  });
});
```

Returns **[Promise][78]&lt;void>** resolves _only_ when `resumeTest()` is invoked

### resumeTest

Resumes a test previously paused by `await pauseTest()`.

## Test Framework APIs




### setResolver

Stores the provided resolver instance so that tests being ran can resolve
objects in the same way as a normal application.

Used by `setupContext` and `setupRenderingContext` as a fallback when `setApplication` was _not_ used.

#### Parameters

-   `resolver` **Ember.Resolver** the resolver to be used for testing

### getResolver

Retrieve the resolver instance stored by `setResolver`.

Returns **Ember.Resolver** the previously stored resolver

### setupContext

Used by test framework addons to setup the provided context for testing.

Responsible for:

-   sets the "global testing context" to the provided context (`setContext`)
-   create an owner object and set it on the provided context (e.g. `this.owner`)
-   setup `this.set`, `this.setProperties`, `this.get`, and `this.getProperties` to the provided context
-   setting up AJAX listeners
-   setting up `pauseTest` (also available as `this.pauseTest()`) and `resumeTest` helpers

#### Parameters

-   `context` **[Object][79]** the context to setup
-   `options` **[Object][79]?** options used to override defaults (optional, default `{}`)
    -   `options.resolver` **Resolver?** a resolver to use for customizing normal resolution

Returns **[Promise][78]&lt;[Object][79]>** resolves with the context that was setup

### getContext

Retrive the "global testing context" as stored by `setContext`.

Returns **[Object][79]** the previously stored testing context

### setContext

Stores the provided context as the "global testing context".

Generally setup automatically by `setupContext`.

#### Parameters

-   `context` **[Object][79]** the context to use

### unsetContext

Clear the "global testing context".

Generally invoked from `teardownContext`.

### teardownContext

Used by test framework addons to tear down the provided context after testing is completed.

Responsible for:

-   un-setting the "global testing context" (`unsetContext`)
-   destroy the contexts owner object
-   remove AJAX listeners

#### Parameters

-   `context` **[Object][79]** the context to setup
-   `options` **[Object][79]?** options used to override defaults
    -   `options.waitForSettled` **[boolean][84]** should the teardown wait for `settled()`ness (optional, default `true`)

Returns **[Promise][78]&lt;void>** resolves when settled

### setupRenderingContext

Used by test framework addons to setup the provided context for rendering.

`setupContext` must have been ran on the provided context
prior to calling `setupRenderingContext`.

Responsible for:

-   Setup the basic framework used for rendering by the
    `render` helper.
-   Ensuring the event dispatcher is properly setup.
-   Setting `this.element` to the root element of the testing
    container (things rendered via `render` will go _into_ this
    element).

#### Parameters

-   `context` **[Object][79]** the context to setup for rendering

Returns **[Promise][78]&lt;[Object][79]>** resolves with the context that was setup

### teardownRenderingContext

Used by test framework addons to tear down the provided context after testing is completed.

Responsible for:

-   resetting the `ember-testing-container` to its original state (the value
    when `setupRenderingContext` was called).

#### Parameters

-   `context` **[Object][79]** the context to setup
-   `options` **[Object][79]?** options used to override defaults
    -   `options.waitForSettled` **[boolean][84]** should the teardown wait for `settled()`ness (optional, default `true`)

Returns **[Promise][78]&lt;void>** resolves when settled

### getApplication

Retrieve the application instance stored by `setApplication`.

Returns **Ember.Application** the previously stored application instance under test

### setApplication

Stores the provided application instance so that tests being ran will be aware of the application under test.

-   Required by `setupApplicationContext` method.
-   Used by `setupContext` and `setupRenderingContext` when present.

#### Parameters

-   `application` **Ember.Application** the application that will be tested

### setupApplicationContext

Used by test framework addons to setup the provided context for working with
an application (e.g. routing).

`setupContext` must have been run on the provided context prior to calling
`setupApplicationContext`.

Sets up the basic framework used by application tests.

#### Parameters

-   `context` **[Object][79]** the context to setup

Returns **[Promise][78]&lt;[Object][79]>** resolves with the context that was setup

### teardownApplicationContext

Used by test framework addons to tear down the provided context after testing is completed.

#### Parameters

-   `context` **[Object][79]** the context to setup
-   `options` **[Object][79]?** options used to override defaults
    -   `options.waitForSettled` **[boolean][84]** should the teardown wait for `settled()`ness (optional, default `true`)

Returns **[Promise][78]&lt;void>** resolves when settled

### validateErrorHandler

Validate the provided error handler to confirm that it properly re-throws
errors when `Ember.testing` is true.

This is intended to be used by test framework hosts (or other libraries) to
ensure that `Ember.onerror` is properly configured. Without a check like
this, `Ember.onerror` could _easily_ swallow all errors and make it _seem_
like everything is just fine (and have green tests) when in reality
everything is on fire...

#### Parameters

-   `callback` **[Function][86]** the callback to validate (optional, default `Ember.onerror`)

#### Examples

Example implementation for `ember-qunit`


```javascript
import { validateErrorHandler } from '@ember/test-helpers';

test('Ember.onerror is functioning properly', function(assert) {
  let result = validateErrorHandler();
  assert.ok(result.isValid, result.message);
});
```

Returns **[Object][79]** object with `isValid` and `message`

## setupOnerror

Sets the Ember.onerror function for the duration of a single test. This
value is reset after each test to ensure correct test isolation.

### Parameters

-   `onError` **[Function][86]** the onError function to be set on Ember.onerror

[1]: #dom-interaction-helpers

[2]: #blur

[3]: #parameters

[4]: #click

[5]: #parameters-1

[6]: #doubleclick

[7]: #parameters-2

[8]: #fillin

[9]: #parameters-3

[10]: #focus

[11]: #parameters-4

[12]: #tap

[13]: #parameters-5

[14]: #triggerevent

[15]: #parameters-6

[16]: #examples

[17]: #triggerkeyevent

[18]: #parameters-7

[19]: #typein

[20]: #parameters-8

[21]: #dom-query-helpers

[22]: #find

[23]: #parameters-9

[24]: #findall

[25]: #parameters-10

[26]: #getrootelement

[27]: #routing-helpers

[28]: #visit

[29]: #parameters-11

[30]: #currentroutename

[31]: #currenturl

[32]: #rendering-helpers

[33]: #render

[34]: #parameters-12

[35]: #clearrender

[36]: #wait-helpers

[37]: #waitfor

[38]: #parameters-13

[39]: #waituntil

[40]: #parameters-14

[41]: #settled

[42]: #issettled

[43]: #getsettledstate

[44]: #pause-helpers

[45]: #pausetest

[46]: #examples-1

[47]: #resumetest

[48]: #test-framework-apis

[49]: #setresolver

[50]: #parameters-15

[51]: #getresolver

[52]: #setupcontext

[53]: #parameters-16

[54]: #getcontext

[55]: #setcontext

[56]: #parameters-17

[57]: #unsetcontext

[58]: #teardowncontext

[59]: #parameters-18

[60]: #setuprenderingcontext

[61]: #parameters-19

[62]: #teardownrenderingcontext

[63]: #parameters-20

[64]: #getapplication

[65]: #setapplication

[66]: #parameters-21

[67]: #setupapplicationcontext

[68]: #parameters-22

[69]: #teardownapplicationcontext

[70]: #parameters-23

[71]: #validateerrorhandler

[72]: #parameters-24

[73]: #examples-2

[74]: #setuponerror

[75]: #parameters-25

[76]: https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String

[77]: https://developer.mozilla.org/docs/Web/API/Element

[78]: https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Promise

[79]: https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object

[80]: https://developer.mozilla.org/en-US/docs/Web/API/Blob

[81]: https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent/key/Key_Values

[82]: https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent/keyCode

[83]: https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Number

[84]: https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean

[85]: https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Array

[86]: https://developer.mozilla.org/docs/Web/JavaScript/Reference/Statements/function
